// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "IBonDriver.h"
#include "TsUtilClass.h"
#include "UsbFx2Driver.h"
#include <vector>
#include <queue>

#define REMOCON_CMD_LEN		8	//e`l̃R񐔂̍ő
#define CHANNEL_MAX			100	//Ƃ肠099ch܂

using std::vector;
using std::queue;


class CBonTuner : public IBonDriver, protected IUsbFx2DriverHost
{
public:
	CBonTuner();
	virtual ~CBonTuner();

	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

	void Release(void);

	static CBonTuner * m_pThis;
	static HINSTANCE m_hModule;

	/*̕Ӓǉ*/
	BOOL GetChannelTable(void);
	BOOL IRCodeTX(BYTE code);
	BOOL IRButtonTX(BYTE button);
	BYTE ConvButtonToCode(BYTE button);


protected:
	virtual const bool OnRecvFifoData(const DWORD dwThreadIndex, const BYTE *pData, const DWORD dwLen, CUsbFx2Driver *pDriver);
	void AllocFifoBuff(void);
	void FreeFifoBuff(void);

	inline void PushFifoBuff(const BYTE *pData);
	
	CUsbFx2Driver *m_pUsbFx2Driver;
	CCriticalLock m_CriticalLock;
	HANDLE m_hOnStreamEvent;

	queue<BYTE *> m_FifoBuffer;
	vector<vector<BYTE>> m_BufferPool;
	DWORD m_dwEmptyFifoPos;

	//ĎדH
	char channel_table[CHANNEL_MAX][REMOCON_CMD_LEN];
	BOOL is_channel_valid;
};
